poj3666(基础dp+离散化)

13 篇文章 0 订阅
10 篇文章 0 订阅

题目链接:http://poj.org/problem?id=3666

Making the Grade
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 9118 Accepted: 4261

Description

A straight dirt road connects two fields on FJ's farm, but it changes elevation more than FJ would like. His cows do not mind climbing up or down a single slope, but they are not fond of an alternating succession of hills and valleys. FJ would like to add and remove dirt from the road so that it becomes one monotonic slope (either sloping up or down).

You are given N integers A1, ... , AN (1 ≤ N ≤ 2,000) describing the elevation (0 ≤ Ai ≤ 1,000,000,000) at each of N equally-spaced positions along the road, starting at the first field and ending at the other. FJ would like to adjust these elevations to a new sequence B1, . ... , BN that is either nonincreasing or nondecreasing. Since it costs the same amount of money to add or remove dirt at any position along the road, the total cost of modifying the road is

| A 1 - B 1| + | A 2 - B 2| + ... + | AN - BN |

Please compute the minimum cost of grading his road so it becomes a continuous slope. FJ happily informs you that signed 32-bit integers can certainly be used to compute the answer.

Input

* Line 1: A single integer: N
* Lines 2..N+1: Line i+1 contains a single integer elevation: Ai

Output

* Line 1: A single integer that is the minimum cost for FJ to grade his dirt road so it becomes nonincreasing or nondecreasing in elevation.

Sample Input

7
1
3
2
4
5
3
9

Sample Output

3

思路:一道基础dp题,做了好久,感觉自己dp做的太少了。。。言归正传,首先这道题可以想到的是每一次变成的新数一定在原序列中(可以用贪心的思想来想)。用dp[i][j],i表示当前处理到第i个数,j表示在b序列(见代码)中排第j的数。因为每一个高度可能达到10亿,所以需要离散化。将它们存入b中,并排序。当然,二维dp可以用滚动数组优化成一维。

在这里附上两种方法的效率比较。

                                                               (二维数组)

                                 

                                                               (滚动数组)

                                 

确实省了很多。。。

代码

//二维数组 
#include<cstdio>
#include<algorithm>
#include<cstdlib>
typedef long long ll;
using namespace std;
ll a[2010];
ll b[2010];
ll n;
ll dp[2010][2010];
bool cmp(ll a,ll b)
{
  return a>b;
}
ll solveup()
{
	sort(b,b+n);
	for(int k=0;k<n;k++)
	dp[0][k]=abs(a[0]-b[k]);
	ll v=0;
	for(int i=1;i<n;i++)
	{
		v=dp[i-1][0];
		for(int j=0;j<n;j++)
		{
			v=min(v,dp[i-1][j]);
			dp[i][j]=v+abs(a[i]-b[j]);
		 } 
	}
     v=dp[n-1][0];
	for(int i=0;i<n;i++)
	v=min(v,dp[n-1][i]);
	return v;
}
ll solvedown()
{
	sort(b,b+n,cmp);
	for(int k=0;k<n;k++)
	dp[0][k]=abs(a[0]-b[k]);
	ll v=0;
	for(int i=1;i<n;i++)
	{
		v=dp[i-1][0];
		for(int j=0;j<n;j++)
		{
			v=min(v,dp[i-1][j]);
			dp[i][j]=v+abs(a[i]-b[j]);
		 } 
	}
	v=dp[n-1][0];
	for(int i=0;i<n;i++)
	v=min(v,dp[n-1][i]);
	return v;
}
int main()
{
	scanf("%lld\n",&n);
	for(int i=0;i<n;i++)
	{
	  scanf("%lld",&a[i]);
	  b[i]=a[i];
    }
	printf("%lld\n",min(solveup(),solvedown()));
	return 0;
} 

//滚动数组 
#include<cstdio>
#include<algorithm>
#include<cstdlib>
typedef long long ll;
using namespace std;
ll a[2010];
ll b[2010];
ll n;
ll dp[2010];
bool cmp(ll a,ll b)
{
  return a>b;
}
ll solveup()
{
	sort(b,b+n);
	for(int k=0;k<n;k++)
	dp[k]=abs(a[0]-b[k]);
	ll v=0;
	for(int i=1;i<n;i++)
	{
		v=dp[0];
		for(int j=0;j<n;j++)
		{
			v=min(v,dp[j]);
			dp[j]=v+abs(a[i]-b[j]);
		 } 
	}
     v=dp[0];
	for(int i=0;i<n;i++)
	v=min(v,dp[i]);
	return v;
}
ll solvedown()
{
	sort(b,b+n,cmp);
	for(int k=0;k<n;k++)
	dp[k]=abs(a[0]-b[k]);
	ll v=0;
	for(int i=1;i<n;i++)
	{
		v=dp[0];
		for(int j=0;j<n;j++)
		{
			v=min(v,dp[j]);
			dp[j]=v+abs(a[i]-b[j]);
		 } 
	}
     v=dp[0];
	for(int i=0;i<n;i++)
	v=min(v,dp[i]);
	return v;
}
int main()
{
	scanf("%lld\n",&n);
	for(int i=0;i<n;i++)
	{
	  scanf("%lld",&a[i]);
	  b[i]=a[i];
    }
	printf("%lld\n",min(solveup(),solvedown()));
	return 0;
} 

  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 3
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 3
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值